function ha=HeikinAshi(ochl)
%ha=HeikinAshi(ochl)
%
%Heikin-Ashi Smoother

    N=length(ochl);
    ha=zeros(N-1,5);

    OPEN=2;
    CLOSE=3;
    HIGH=4;
    LOW=5;
    ha(1,:)=ochl(1,1:5);

    for n=2:N
        ha(n,CLOSE)=(ochl(n,OPEN)+ochl(n,CLOSE)+ochl(n,HIGH)+ochl(n,LOW))*0.25;
        ha(n,OPEN)=(ha(n-1,OPEN)+ha(n-1,CLOSE))*0.5;
        ha(n,HIGH)=max([ochl(n,HIGH);ha(n,OPEN);ha(n,CLOSE)]);
        ha(n,LOW)=min([ochl(n,LOW);ha(n,OPEN);ha(n,CLOSE)]);
    end
end